Loading...
Searching...
No Matches
gridfire::engine::FileDefinedEngineView Class Referencefinal

`#include <engine_defined.h>`

Inheritance diagram for gridfire::engine::FileDefinedEngineView:
[legend]
Collaboration diagram for gridfire::engine::FileDefinedEngineView:
[legend]

## Public Member Functions

| FileDefinedEngineView (GraphEngine &baseEngine, const std::string &fileName, const io::NetworkFileParser &parser)
| FileDefinedEngineView Implementation ///.
std::string | getNetworkFile () const
const io::NetworkFileParser & | getParser () const
Public Member Functions inherited from gridfire::engine::DefinedEngineView
| DefinedEngineView (const std::vector< std::string > &peNames, GraphEngine &baseEngine)
const DynamicEngine & | getBaseEngine () const override
| Get the base engine associated with this defined engine view.
const std::vector< fourdst::atomic::Species > & | getNetworkSpecies (scratch::StateBlob &ctx) const override
| Gets the list of active species in the network defined by the file.
std::expected< StepDerivatives< double >, EngineStatus > | calculateRHSAndEnergy (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho, bool trust) const override
| Calculates the right-hand side (dY/dt) and energy generation for the active species.
EnergyDerivatives | calculateEpsDerivatives (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Calculate the derivatives of the energy generation rate with respect to T and rho.
NetworkJacobian | generateJacobianMatrix (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Generates the Jacobian matrix for the active species.
NetworkJacobian | generateJacobianMatrix (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho, const std::vector< fourdst::atomic::Species > &activeSpecies) const override
| Generates the Jacobian matrix for the active species.
NetworkJacobian | generateJacobianMatrix (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho, const SparsityPattern &sparsityPattern) const override
| Generates the Jacobian matrix for a given sparsity pattern.
double | calculateMolarReactionFlow (scratch::StateBlob &ctx, const reaction::Reaction &reaction, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Calculates the molar reaction flow for a given reaction in the active network.
const reaction::ReactionSet & | getNetworkReactions (scratch::StateBlob &ctx) const override
| Gets the set of active logical reactions in the network.
std::expected< std::unordered_map< fourdst::atomic::Species, double >, EngineStatus > | getSpeciesTimescales (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Computes timescales for all active species in the network.
std::expected< std::unordered_map< fourdst::atomic::Species, double >, EngineStatus > | getSpeciesDestructionTimescales (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Computes destruction timescales for all active species in the network.
fourdst::composition::Composition | project (scratch::StateBlob &ctx, const NetIn &netIn) const override
| Updates the engine view if it is marked as stale.
screening::ScreeningType | getScreeningModel (scratch::StateBlob &ctx) const override
| Gets the screening model from the base engine.
size_t | getSpeciesIndex (scratch::StateBlob &ctx, const fourdst::atomic::Species &species) const override
| Maps a species from the full network to its index in the defined active network.
PrimingReport | primeEngine (scratch::StateBlob &ctx, const NetIn &netIn) const override
| Prime the engine view for calculations. This will delegate to the base engine.
fourdst::composition::Composition | collectComposition (scratch::StateBlob &ctx, const fourdst::composition::CompositionAbstract &comp, double T9, double rho) const override
| Collects a Composition object from the base engine.
SpeciesStatus | getSpeciesStatus (scratch::StateBlob &ctx, const fourdst::atomic::Species &species) const override
| Gets the status of a species in the active network.
std::optional< StepDerivatives< double > > | getMostRecentRHSCalculation (scratch::StateBlob &ctx) const override
std::unique_ptr< scratch::StateBlob > | constructStateBlob (const scratch::StateBlob *blob) const override
Public Member Functions inherited from gridfire::engine::DynamicEngine
virtual reaction::ReactionSet | getInactiveNetworkReactions (scratch::StateBlob &ctx) const
| Get the set of inactive reactions in the network.
virtual double | getInactiveReactionMolarReactionFlow (scratch::StateBlob &ctx, const reaction::Reaction &reaction, const fourdst::composition::CompositionAbstract &comp, const double T9, const double rho) const
Public Member Functions inherited from gridfire::engine::Engine
virtual | ~Engine ()=default
| Virtual destructor.
Public Member Functions inherited from gridfire::engine::EngineView< DynamicEngine >
virtual | ~EngineView ()=default
| Virtual destructor.

## Private Attributes

Config< config::GridFireConfig > | m_config
quill::Logger * | m_logger = LogManager::getInstance().getLogger("log")
std::string | m_fileName
| Parser for the network file.
const io::NetworkFileParser & | m_parser

## Additional Inherited Members

Protected Attributes inherited from gridfire::engine::DefinedEngineView
bool | m_isStale = true
GraphEngine & | m_baseEngine

## Constructor & Destructor Documentation

## FileDefinedEngineView()

gridfire::engine::FileDefinedEngineView::FileDefinedEngineView | ( | GraphEngine & | baseEngine,
|  | const std::string & | fileName,
|  | const io::NetworkFileParser & | parser )

explicit

FileDefinedEngineView Implementation ///.

## Member Function Documentation

## getNetworkFile()

std::string gridfire::engine::FileDefinedEngineView::getNetworkFile | ( |  | ) | const

inlinenodiscard

## getParser()

const io::NetworkFileParser & gridfire::engine::FileDefinedEngineView::getParser | ( |  | ) | const

inlinenodiscard

## Member Data Documentation

## m_config

Config<config::GridFireConfig> gridfire::engine::FileDefinedEngineView::m_config

private

## m_fileName

std::string gridfire::engine::FileDefinedEngineView::m_fileName

private

Parser for the network file.

## m_logger

quill::Logger* gridfire::engine::FileDefinedEngineView::m_logger = LogManager::getInstance().getLogger("log")

private

## m_parser

const io::NetworkFileParser& gridfire::engine::FileDefinedEngineView::m_parser

private

The documentation for this class was generated from the following files:

- src/include/gridfire/engine/views/engine_defined.h
- src/lib/engine/views/engine_defined.cpp